import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Locale;
import java.util.Scanner;
import java.util.StringTokenizer;

public class BuildCdFile {

    public static void main(String[] args) {
        // TODO Auto-generated method stub
        
        Locale.setDefault(Locale.US);
        
        Scanner sc = null;
        try {
            sc = new Scanner(new File("stela_drag_coefficient.txt"));
        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
        final ArrayList<double[]> list = new ArrayList<double[]>();
        
        while ( sc.hasNext() ) {
            
            final String line = sc.nextLine();
            if ( ! line.startsWith("#") ) {
                final StringTokenizer st = new StringTokenizer(line);
                final double alt = Double.parseDouble(st.nextToken());
                final double cd  = Double.parseDouble(st.nextToken());
                final double[] tab = { alt, cd };
                list.add(tab);
            }
        }
        
        int nbPts = list.size();
        System.out.println(list.get(0)[0]);
        System.out.println(list.get(nbPts-1)[0]);
        
        sc.close();
        
        FileWriter xmlFile;
        try {
            xmlFile = new FileWriter(new File("stela_drag_coefficient.xml"));
            xmlFile.write("<AerodynamicProperties name=\"AerodynamicProperties\">\n");
            xmlFile.write("  <String name=\"coefficientType\">Tabulated</String>\n");
            xmlFile.write("  <String name=\"tableType\">Altitude</String>\n");
            xmlFile.write("  <Array name=\"functionOfAltitude\">\n");
            xmlFile.write("    <Array name=\"altitudeArray\" unit=\"km\">\n");
            for (int i = 0; i < nbPts; i++) {
                xmlFile.write(String.format("      <Real name=\"%d\">%8.2e</Real>\n", i, list.get(i)[0]));
            }
            xmlFile.write("    </Array>\n");
            xmlFile.write("    <Array name=\"CxAltitude\">\n");
            for (int i = 0; i < nbPts; i++) {
                xmlFile.write(String.format("      <Real name=\"%d\">%8.2e</Real>\n", i, list.get(i)[1]));
            }
            xmlFile.write("    </Array>\n");
            xmlFile.write("    <Array name=\"CzAltitude\">\n");
            for (int i = 0; i < nbPts; i++) {
                xmlFile.write(String.format("      <Real name=\"%d\">%8.2e</Real>\n", i, 0.));
            }
            xmlFile.write("    </Array>\n");
            xmlFile.write("  </Array>\n");
            xmlFile.write("</AerodynamicProperties>\n");
            xmlFile.close();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        


    }

}
